;;; 
;;; Dipole calculus
;;;

(def-calculus "Dipole relation algebra (DRA)"
  :arity                   :binary
  :basis-entity            :dipole
  :parametric?             nil
  :consistency             :unknown
  :identity-relation       sese 
  :qualifier               (external-lib "libdipole.dylib" "dipole_qualify")
  :algebraic-specification ((l??? (0 > (-1 ((sax 1)(eay 1))) ( 1 ((sax 1)(sby 1))) (1 ((say 1)(eax 1)))
				      (-1 ((say 1)(sbx 1))) (-1 ((eax 1)(sby 1))) (1 ((eay 1)(sbx 1)))))
			    (?l?? (0 > (-1 ((sax 1)(eay 1))) ( 1 ((sax 1)(eby 1))) (1 ((say 1)(eax 1)))
				      (-1 ((say 1)(ebx 1))) (-1 ((eax 1)(eby 1))) (1 ((eay 1)(ebx 1)))))
			    (??l? (0 > (-1 ((sax 1)(sby 1))) ( 1 ((sax 1)(eby 1))) (1 ((say 1)(sbx 1)))
				      (-1 ((say 1)(ebx 1))) (-1 ((sbx 1)(eby 1))) (1 ((sby 1)(ebx 1)))))
			    (???l (0 > (-1 ((eax 1)(sby 1))) ( 1 ((eax 1)(eby 1))) (1 ((eay 1)(sbx 1)))
				      (-1 ((eay 1)(ebx 1))) (-1 ((sbx 1)(eby 1))) (1 ((sby 1)(ebx 1)))))
			    (r??? (0 < (-1 ((sax 1)(eay 1))) ( 1 ((sax 1)(sby 1))) (1 ((say 1)(eax 1)))
				      (-1 ((say 1)(sbx 1))) (-1 ((eax 1)(sby 1))) (1 ((eay 1)(sbx 1)))))
			    (?r?? (0 < (-1 ((sax 1)(eay 1))) ( 1 ((sax 1)(eby 1))) (1 ((say 1)(eax 1)))
				      (-1 ((say 1)(ebx 1))) (-1 ((eax 1)(eby 1))) (1 ((eay 1)(ebx 1)))))
			    (??r? (0 < (-1 ((sax 1)(sby 1))) ( 1 ((sax 1)(eby 1))) (1 ((say 1)(sbx 1)))
				      (-1 ((say 1)(ebx 1))) (-1 ((sbx 1)(eby 1))) (1 ((sby 1)(ebx 1)))))
			    (???r (0 < (-1 ((eax 1)(sby 1))) ( 1 ((eax 1)(eby 1))) (1 ((eay 1)(sbx 1)))
				      (-1 ((eay 1)(ebx 1))) (-1 ((sbx 1)(eby 1))) (1 ((sby 1)(ebx 1)))))
			    (s?s?  ((1 ((sax 1))) = (1 ((sbx 1))))
				   ((1 ((say 1))) = (1 ((sby 1)))))
			    (?se?  ((1 ((sax 1))) = (1 ((ebx 1))))
				   ((1 ((say 1))) = (1 ((eby 1)))))
			    (e??s  ((1 ((eax 1))) = (1 ((sbx 1))))
				   ((1 ((eay 1))) = (1 ((sby 1)))))
			    (?e?e  ((1 ((eax 1))) = (1 ((ebx 1))))
				   ((1 ((eay 1))) = (1 ((eby 1))))))
  :converse-operation ((rrrr rrrr)
                       (rrrl rlrr)
                       (rrlr lrrr)
                       (rrll llrr)
                       (rlrr rrrl)
                       (rllr lrrl)
                       (rlll llrl)
                       (lrrr rrlr)
                       (lrrl rllr)
                       (lrll lllr)
                       (llrr rrll)
                       (llrl rlll)
                       (lllr lrll)
                       (llll llll)
                       (ells lsel)
                       (errs rser)
                       (lere rele)
                       (rele lere)
                       (slsr srsl)
                       (srsl slsr)
                       (lsel ells)
                       (rser errs)
                       (sese sese)
                       (eses eses))  
  
  :base-relations (rrrr rrrl rrlr rrll rlrr rllr rlll lrrr lrrl lrll llrr llrl lllr llll ells errs lere rele slsr srsl lsel rser sese eses)
  :composition-operation 
  (
   (RRRR RRRR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (RRRR RRRL (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (RRRR RRLR (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (RRRR RRLL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (RRRR RLRR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RRRR RLLR (RRRR RRRL RRLL RLRR RLLL LRRR LRRL LRLL ERRS SRSL ))
   (RRRR RLLL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RRRR LRRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RRRR LRRL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRLL RELE RSER ))
   (RRRR LRLL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RRRR LLRR (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (RRRR LLRL (RRRR RRLR RRLL LRRR LRLL LLRR LLLL ))
   (RRRR LLLR (RRRR RRRL RRLL RLRR RLLL LLRR LLLL ))
   (RRRR LLLL (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (RRRR ELLS (RRRR RRRL RRLL RLRR RLLL ))
   (RRRR ERRS (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RRRR LERE (RRRR RRLR RRLL LRRR LRLL ))
   (RRRR RELE (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RRRR SLSR (RRRR RRRL RRLL RLRR RLLL ))
   (RRRR SRSL (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RRRR LSEL (RRRR RRLR RRLL LRRR LRLL ))
   (RRRR RSER (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RRRR SESE (RRRR ))
   (RRRR ESES (RRLL ))
   (RRRL RRRR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RRRL RRRL (RRRR RRRL RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (RRRL RRLR (RRRL RRLR RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (RRRL RRLL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RRRL RLRR (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (RRRL RLLR (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (RRRL RLLL (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (RRRL LRRR (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (RRRL LRRL (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (RRRL LRLL (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (RRRL LLRR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RRRL LLRL (RRRR RRRL RRLR LRRR LRRL LLRR LLRL ERRS LERE ))
   (RRRL LLLR (RRRL RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (RRRL LLLL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RRRL ELLS (RRRL RRLR RRLL RLLR RLLL RELE ))
   (RRRL ERRS (RRRR RRRL RRLR RLRR RLLR RSER ))
   (RRRL LERE (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (RRRL RELE (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (RRRL SLSR (RRRL RRLR RRLL RLLR RLLL RELE ))
   (RRRL SRSL (RRRR RRRL RRLR RLRR RLLR RSER ))
   (RRRL LSEL (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (RRRL RSER (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (RRRL SESE (RRRL ))
   (RRRL ESES (RRLR ))
   (RRLR RRRR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RRLR RRRL (RRRL RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (RRLR RRLR (RRRR RRRL RRLR LRRR LRRL LLRR LLRL ERRS LERE ))
   (RRLR RRLL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RRLR RLRR (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (RRLR RLLR (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (RRLR RLLL (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (RRLR LRRR (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (RRLR LRRL (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (RRLR LRLL (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (RRLR LLRR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RRLR LLRL (RRRL RRLR RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (RRLR LLLR (RRRR RRRL RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (RRLR LLLL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RRLR ELLS (RRRR RRRL RRLR RLRR RLLR RSER ))
   (RRLR ERRS (RRRL RRLR RRLL RLLR RLLL RELE ))
   (RRLR LERE (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (RRLR RELE (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (RRLR SLSR (RRRR RRRL RRLR RLRR RLLR RSER ))
   (RRLR SRSL (RRRL RRLR RRLL RLLR RLLL RELE ))
   (RRLR LSEL (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (RRLR RSER (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (RRLR SESE (RRLR ))
   (RRLR ESES (RRRL ))
   (RRLL RRRR (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (RRLL RRRL (RRRR RRRL RRLL RLRR RLLL LLRR LLLL ))
   (RRLL RRLR (RRRR RRLR RRLL LRRR LRLL LLRR LLLL ))
   (RRLL RRLL (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (RRLL RLRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RRLL RLLR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRLL RELE RSER ))
   (RRLL RLLL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RRLL LRRR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RRLL LRRL (RRRR RRRL RRLL RLRR RLLL LRRR LRRL LRLL ERRS SRSL ))
   (RRLL LRLL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RRLL LLRR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (RRLL LLRL (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (RRLL LLLR (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (RRLL LLLL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (RRLL ELLS (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RRLL ERRS (RRRR RRRL RRLL RLRR RLLL ))
   (RRLL LERE (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RRLL RELE (RRRR RRLR RRLL LRRR LRLL ))
   (RRLL SLSR (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RRLL SRSL (RRRR RRRL RRLL RLRR RLLL ))
   (RRLL LSEL (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RRLL RSER (RRRR RRLR RRLL LRRR LRLL ))
   (RRLL SESE (RRLL ))
   (RRLL ESES (RRRR ))
   (RLRR RRRR (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (RLRR RRRL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (RLRR RRLR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (RLRR RRLL (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (RLRR RLRR (RRRR RRRL RRLL RLRR LRRR LRRL LRLL ERRS SRSL ))
   (RLRR RLLR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RLRR RLLL (RLRR RLLR RLLL LRLL LLRR LLLR LLLL ELLS SLSR ))
   (RLRR LRRR (RLRR LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (RLRR LRRL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RLRR LRLL (RRRR RRLR RRLL RLRR RLLR RLLL LRLL RELE RSER ))
   (RLRR LLRR (RRRR RRRL RRLL RLRR LLRR LLRL LLLL ))
   (RLRR LLRL (RRRR RRLR RRLL RLRR LRLL LLRR LLRL LLLL ))
   (RLRR LLLR (RRRR RRRL RRLL RLRR LRLL LLRR LLLR LLLL ))
   (RLRR LLLL (RRRR RRLR RRLL LRLL LLRR LLLR LLLL ))
   (RLRR ELLS (LRLL LLRR LLLR LLLL ))
   (RLRR ERRS (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (RLRR LERE (RLRR LLRR LLRL LLLL ))
   (RLRR RELE (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (RLRR SLSR (RRRR RRRL RRLL RLRR ))
   (RLRR SRSL (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RLRR LSEL (RRRR RRLR RRLL LRLL ))
   (RLRR RSER (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RLRR SESE (RLRR ))
   (RLRR ESES (LRLL ))
   (RLLR RRRR (RRRR RRRL RRLR LRRR LRRL LLRR LLRL LLLR ERRS LERE ))
   (RLLR RRRL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RLLR RRLR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (RLLR RRLL (RRRL RRLR RRLL RLLR RLLL LLRL LLLR LLLL ELLS RELE ))
   (RLLR RLRR (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (RLLR RLLR (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (RLLR RLLL (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (RLLR LRRR (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (RLLR LRRL (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (RLLR LRLL (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (RLLR LLRR (RRRR RRRL RRLR RLRR RLLR LLRR LLRL LLLR SLSR RSER ))
   (RLLR LLRL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RLLR LLLR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (RLLR LLLL (RRRL RRLR RRLL LRRL LRLL LLRL LLLR LLLL SRSL LSEL ))
   (RLLR ELLS (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (RLLR ERRS (LRRR LRRL LLRR LLRL LLLR LERE ))
   (RLLR LERE (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (RLLR RELE (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (RLLR SLSR (RRRR RRRL RRLR RLRR RLLR RSER ))
   (RLLR SRSL (RRRL RRLR RRLL RLLR RLLL RELE ))
   (RLLR LSEL (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (RLLR RSER (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (RLLR SESE (RLLR ))
   (RLLR ESES (LRRL ))
   (RLLL RRRR (RRRR RRLR RRLL LRRR LLRR LLLR LLLL ))
   (RLLL RRRL (RRRR RRRL RRLL RLLL LRRR LLRR LLLR LLLL ))
   (RLLL RRLR (RRRR RRLR RRLL RLLL LRRR LLRR LLRL LLLL ))
   (RLLL RRLL (RRRR RRRL RRLL RLLL LLRR LLRL LLLL ))
   (RLLL RLRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR RELE RSER ))
   (RLLL RLLR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (RLLL RLLL (RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (RLLL LRRR (RLRR RLLR RLLL LRRR LLRR LLLR LLLL ELLS SLSR ))
   (RLLL LRRL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (RLLL LRLL (RRRR RRRL RRLL RLLL LRRR LRRL LRLL ERRS SRSL ))
   (RLLL LLRR (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (RLLL LLRL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (RLLL LLLR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (RLLL LLLL (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (RLLL ELLS (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (RLLL ERRS (LRRR LLRR LLLR LLLL ))
   (RLLL LERE (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (RLLL RELE (RLLL LLRR LLRL LLLL ))
   (RLLL SLSR (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (RLLL SRSL (RRRR RRRL RRLL RLLL ))
   (RLLL LSEL (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (RLLL RSER (RRRR RRLR RRLL LRRR ))
   (RLLL SESE (RLLL ))
   (RLLL ESES (LRRR ))
   (LRRR RRRR (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (LRRR RRRL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (LRRR RRLR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (LRRR RRLL (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (LRRR RLRR (RLRR RLLR RLLL LRRR LLRR LLLR LLLL ELLS SLSR ))
   (LRRR RLLR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LRRR RLLL (RRRR RRRL RRLL RLLL LRRR LRRL LRLL ERRS SRSL ))
   (LRRR LRRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR RELE RSER ))
   (LRRR LRRL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LRRR LRLL (RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LRRR LLRR (RRRR RRLR RRLL LRRR LLRR LLLR LLLL ))
   (LRRR LLRL (RRRR RRLR RRLL RLLL LRRR LLRR LLRL LLLL ))
   (LRRR LLLR (RRRR RRRL RRLL RLLL LRRR LLRR LLLR LLLL ))
   (LRRR LLLL (RRRR RRRL RRLL RLLL LLRR LLRL LLLL ))
   (LRRR ELLS (RRRR RRRL RRLL RLLL ))
   (LRRR ERRS (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (LRRR LERE (RRRR RRLR RRLL LRRR ))
   (LRRR RELE (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (LRRR SLSR (LRRR LLRR LLLR LLLL ))
   (LRRR SRSL (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LRRR LSEL (RLLL LLRR LLRL LLLL ))
   (LRRR RSER (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LRRR SESE (LRRR ))
   (LRRR ESES (RLLL ))
   (LRRL RRRR (RRRR RRRL RRLR RLRR RLLR LLRR LLRL LLLR SLSR RSER ))
   (LRRL RRRL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LRRL RRLR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LRRL RRLL (RRRL RRLR RRLL LRRL LRLL LLRL LLLR LLLL SRSL LSEL ))
   (LRRL RLRR (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (LRRL RLLR (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (LRRL RLLL (RRRL RRLR RRLL RLLR RLLL LRRL LRLL RELE SRSL ))
   (LRRL LRRR (RRRR RRRL RRLR RLRR RLLR LRRR LRRL ERRS RSER ))
   (LRRL LRRL (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (LRRL LRLL (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (LRRL LLRR (RRRR RRRL RRLR LRRR LRRL LLRR LLRL LLLR ERRS LERE ))
   (LRRL LLRL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LRRL LLLR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LRRL LLLL (RRRL RRLR RRLL RLLR RLLL LLRL LLLR LLLL ELLS RELE ))
   (LRRL ELLS (RRRL RRLR RRLL RLLR RLLL RELE ))
   (LRRL ERRS (RRRR RRRL RRLR RLRR RLLR RSER ))
   (LRRL LERE (RRRR RRRL RRLR LRRR LRRL ERRS ))
   (LRRL RELE (RRRL RRLR RRLL LRRL LRLL SRSL ))
   (LRRL SLSR (LRRR LRRL LLRR LLRL LLLR LERE ))
   (LRRL SRSL (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (LRRL LSEL (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (LRRL RSER (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (LRRL SESE (LRRL ))
   (LRRL ESES (RLLR ))
   (LRLL RRRR (RRRR RRRL RRLL RLRR LLRR LLRL LLLL ))
   (LRLL RRRL (RRRR RRRL RRLL RLRR LRLL LLRR LLLR LLLL ))
   (LRLL RRLR (RRRR RRLR RRLL RLRR LRLL LLRR LLRL LLLL ))
   (LRLL RRLL (RRRR RRLR RRLL LRLL LLRR LLLR LLLL ))
   (LRLL RLRR (RLRR LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LRLL RLLR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LRLL RLLL (RRRR RRLR RRLL RLRR RLLR RLLL LRLL RELE RSER ))
   (LRLL LRRR (RRRR RRRL RRLL RLRR LRRR LRRL LRLL ERRS SRSL ))
   (LRLL LRRL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LRLL LRLL (RLRR RLLR RLLL LRLL LLRR LLLR LLLL ELLS SLSR ))
   (LRLL LLRR (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (LRLL LLRL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (LRLL LLLR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (LRLL LLLL (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (LRLL ELLS (RRRR RRLR RRLL RLRR RLLR RLLL RELE RSER ))
   (LRLL ERRS (RRRR RRRL RRLL RLRR ))
   (LRLL LERE (RRRR RRRL RRLL LRRR LRRL LRLL ERRS SRSL ))
   (LRLL RELE (RRRR RRLR RRLL LRLL ))
   (LRLL SLSR (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LRLL SRSL (LRLL LLRR LLLR LLLL ))
   (LRLL LSEL (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LRLL RSER (RLRR LLRR LLRL LLLL ))
   (LRLL SESE (LRLL ))
   (LRLL ESES (RLRR ))
   (LLRR RRRR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (LLRR RRRL (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (LLRR RRLR (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (LLRR RRLL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (LLRR RLRR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LLRR RLLR (RLRR RLLR RLLL LRRR LRLL LLRR LLLR LLLL ELLS SLSR ))
   (LLRR RLLL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LLRR LRRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LLRR LRRL (RLRR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLRR LRLL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LLRR LLRR (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (LLRR LLRL (RRRR RRLL RLRR RLLL LLRR LLRL LLLL ))
   (LLRR LLLR (RRRR RRLL LRRR LRLL LLRR LLLR LLLL ))
   (LLRR LLLL (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (LLRR ELLS (LRRR LRLL LLRR LLLR LLLL ))
   (LLRR ERRS (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLRR LERE (RLRR RLLL LLRR LLRL LLLL ))
   (LLRR RELE (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LLRR SLSR (LRRR LRLL LLRR LLLR LLLL ))
   (LLRR SRSL (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLRR LSEL (RLRR RLLL LLRR LLRL LLLL ))
   (LLRR RSER (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LLRR SESE (LLRR ))
   (LLRR ESES (LLLL ))
   (LLRL RRRR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LLRL RRRL (RRRL RRLL LRRL LRLL LLRL LLLR LLLL SRSL LSEL ))
   (LLRL RRLR (RRRR RRLR RLRR RLLR LLRR LLRL LLLR SLSR RSER ))
   (LLRL RRLL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LLRL RLRR (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (LLRL RLLR (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (LLRL RLLL (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (LLRL LRRR (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (LLRL LRRL (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (LLRL LRLL (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (LLRL LLRR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LLRL LLRL (RRLR RRLL RLLR RLLL LLRL LLLR LLLL ELLS RELE ))
   (LLRL LLLR (RRRR RRRL LRRR LRRL LLRR LLRL LLLR ERRS LERE ))
   (LLRL LLLL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LLRL ELLS (LRRR LRRL LLRR LLRL LLLR LERE ))
   (LLRL ERRS (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (LLRL LERE (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (LLRL RELE (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (LLRL SLSR (LRRR LRRL LLRR LLRL LLLR LERE ))
   (LLRL SRSL (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (LLRL LSEL (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (LLRL RSER (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (LLRL SESE (LLRL ))
   (LLRL ESES (LLLR ))
   (LLLR RRRR (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LLLR RRRL (RRRR RRRL LRRR LRRL LLRR LLRL LLLR ERRS LERE ))
   (LLLR RRLR (RRLR RRLL RLLR RLLL LLRL LLLR LLLL ELLS RELE ))
   (LLLR RRLL (RRRR RRRL RRLR RRLL RLLR RLLL LRRR LRRL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE ))
   (LLLR RLRR (RRRR RRRL RRLR RLRR RLLR RLLL LRRR LRRL LRLL LLRL LLLR LLLL ELLS ERRS LSEL RSER ESES ))
   (LLLR RLLR (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (LLLR RLLL (RLLR RLLL LRRL LRLL LLRL LLLR LLLL ELLS LSEL ))
   (LLLR LRRR (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (LLLR LRRL (RLRR RLLR LRRR LRRL LLRR LLRL LLLR LERE SLSR ))
   (LLLR LRLL (RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LERE RELE SLSR SRSL SESE ))
   (LLLR LLRR (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LLLR LLRL (RRRR RRLR RLRR RLLR LLRR LLRL LLLR SLSR RSER ))
   (LLLR LLLR (RRRL RRLL LRRL LRLL LLRL LLLR LLLL SRSL LSEL ))
   (LLLR LLLL (RRRR RRRL RRLR RRLL RLRR RLLR LRRL LRLL LLRR LLRL LLLR LLLL SLSR SRSL LSEL RSER ))
   (LLLR ELLS (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (LLLR ERRS (LRRR LRRL LLRR LLRL LLLR LERE ))
   (LLLR LERE (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (LLLR RELE (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (LLLR SLSR (LRRL LRLL LLRL LLLR LLLL LSEL ))
   (LLLR SRSL (LRRR LRRL LLRR LLRL LLLR LERE ))
   (LLLR LSEL (RLRR RLLR LLRR LLRL LLLR SLSR ))
   (LLLR RSER (RLLR RLLL LLRL LLLR LLLL ELLS ))
   (LLLR SESE (LLLR ))
   (LLLR ESES (LLRL ))
   (LLLL RRRR (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (LLLL RRRL (RRRR RRLL LRRR LRLL LLRR LLLR LLLL ))
   (LLLL RRLR (RRRR RRLL RLRR RLLL LLRR LLRL LLLL ))
   (LLLL RRLL (RRRR RRRL RRLR RRLL RLRR RLLL LRRR LRLL LLRR LLRL LLLR LLLL ))
   (LLLL RLRR (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LLLL RLLR (RLRR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLLL RLLL (RRRR RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLL LERE RELE LSEL RSER ))
   (LLLL LRRR (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LLLL LRRL (RLRR RLLR RLLL LRRR LRLL LLRR LLLR LLLL ELLS SLSR ))
   (LLLL LRLL (RRRR RRRL RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLLR LLLL ELLS ERRS SLSR SRSL ))
   (LLLL LLRR (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER ESES ))
   (LLLL LLRL (RRRR RRLR RRLL RLRR RLLR RLLL LLRR LLLR LLLL ELLS RELE SLSR RSER ))
   (LLLL LLLR (RRRR RRRL RRLL LRRR LRRL LRLL LLRR LLRL LLLL ERRS LERE SRSL LSEL ))
   (LLLL LLLL (RRRR RRRL RRLR RRLL RLRR RLLR RLLL LRRR LRRL LRLL LLRR LLRL LLLR LLLL ELLS ERRS LERE RELE SLSR SRSL LSEL RSER SESE ))
   (LLLL ELLS (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLLL ERRS (LRRR LRLL LLRR LLLR LLLL ))
   (LLLL LERE (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LLLL RELE (RLRR RLLL LLRR LLRL LLLL ))
   (LLLL SLSR (LRRR LRRL LRLL LLRR LLRL LLLL LERE LSEL ))
   (LLLL SRSL (LRRR LRLL LLRR LLLR LLLL ))
   (LLLL LSEL (RLRR RLLR RLLL LLRR LLLR LLLL ELLS SLSR ))
   (LLLL RSER (RLRR RLLL LLRR LLRL LLLL ))
   (LLLL SESE (LLLL ))
   (LLLL ESES (LLRR ))
   (ELLS RRRR (RRRR RRLR LRRR LLRR LLLR ))
   (ELLS RRRL (RRRR LRRR LLRR LLLR ))
   (ELLS RRLR (RRLL RLLL LLRL LLLL ))
   (ELLS RRLL (RRRL RRLL RLLL LLRL LLLL ))
   (ELLS RLRR (RRRR RRLR RLRR RLLR LRRR RSER ))
   (ELLS RLLR (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (ELLS RLLL (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (ELLS LRRR (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (ELLS LRRL (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (ELLS LRLL (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (ELLS LLRR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (ELLS LLRL (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (ELLS LLLR (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (ELLS LLLL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (ELLS ELLS (LRRL LRLL LLRL LLLL LSEL ))
   (ELLS ERRS (LRRR LLRR LLLR ))
   (ELLS LERE (RLRR RLLR LLRR LLLR SLSR ))
   (ELLS RELE (RLLL LLRL LLLL ))
   (ELLS SLSR (ELLS ERRS ESES ))
   (ELLS SRSL (ELLS ERRS ))
   (ELLS LSEL (LERE RELE SESE ))
   (ELLS RSER (LERE RELE ))
   (ELLS SESE (ELLS ))
   (ELLS ESES (LERE ))
   (ERRS RRRR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (ERRS RRRL (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (ERRS RRLR (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (ERRS RRLL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (ERRS RLRR (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (ERRS RLLR (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (ERRS RLLL (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (ERRS LRRR (RRRR RRLR RLRR RLLR LRRR RSER ))
   (ERRS LRRL (RRRR RRLR RLRR RLLR LRRR RSER ))
   (ERRS LRLL (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (ERRS LLRR (RRRR RRLR LRRR LLRR LLLR ))
   (ERRS LLRL (RRRR RRLR LRRR LLRR ))
   (ERRS LLLR (RRRL RRLL RLLL LLLL ))
   (ERRS LLLL (RRRL RRLL RLLL LLRL LLLL ))
   (ERRS ELLS (RRRL RRLL RLLL ))
   (ERRS ERRS (RRRR RRLR RLRR RLLR RSER ))
   (ERRS LERE (RRRR RRLR LRRR ))
   (ERRS RELE (RRRL RRLL LRRL LRLL SRSL ))
   (ERRS SLSR (ELLS ERRS ))
   (ERRS SRSL (ELLS ERRS ESES ))
   (ERRS LSEL (LERE RELE ))
   (ERRS RSER (LERE RELE SESE ))
   (ERRS SESE (ERRS ))
   (ERRS ESES (RELE ))
   (LERE RRRR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (LERE RRRL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (LERE RRLR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (LERE RRLL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (LERE RLRR (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (LERE RLLR (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (LERE RLLL (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (LERE LRRR (RRRR RRLR RLRR RLLR LRRR RSER ))
   (LERE LRRL (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (LERE LRLL (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (LERE LLRR (RRRR RRLR LRRR LLRR LLLR ))
   (LERE LLRL (RRLL RLLL LLRL LLLL ))
   (LERE LLLR (RRRR LRRR LLRR LLLR ))
   (LERE LLLL (RRRL RRLL RLLL LLRL LLLL ))
   (LERE ELLS (ELLS ERRS ))
   (LERE ERRS (ELLS ERRS ESES ))
   (LERE LERE (LERE RELE ))
   (LERE RELE (LERE RELE SESE ))
   (LERE SLSR (LRRR LLRR LLLR ))
   (LERE SRSL (LRRL LRLL LLRL LLLL LSEL ))
   (LERE LSEL (RLLL LLRL LLLL ))
   (LERE RSER (RLRR RLLR LLRR LLLR SLSR ))
   (LERE SESE (LERE ))
   (LERE ESES (ELLS ))
   (RELE RRRR (RRRR RRLR LRRR LLRR LLLR ))
   (RELE RRRL (RRRL RRLL RLLL LLLL ))
   (RELE RRLR (RRRR RRLR LRRR LLRR ))
   (RELE RRLL (RRRL RRLL RLLL LLRL LLLL ))
   (RELE RLRR (RRRR RRLR RLRR RLLR LRRR RSER ))
   (RELE RLLR (RRRR RRLR RLRR RLLR LRRR RSER ))
   (RELE RLLL (RLLL LRRL LRLL LLRL LLLL LSEL ))
   (RELE LRRR (RLRR RLLR LRRR LLRR LLLR SLSR ))
   (RELE LRRL (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (RELE LRLL (RRRL RRLL RLLL LRRL LRLL SRSL ))
   (RELE LLRR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (RELE LLRL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (RELE LLLR (RRRR RRLR RLRR RLLR LLRR LLLR SLSR RSER ))
   (RELE LLLL (RRRL RRLL LRRL LRLL LLRL LLLL SRSL LSEL ))
   (RELE ELLS (ELLS ERRS ESES ))
   (RELE ERRS (ELLS ERRS ))
   (RELE LERE (LERE RELE SESE ))
   (RELE RELE (LERE RELE ))
   (RELE SLSR (RRRR RRLR RLRR RLLR RSER ))
   (RELE SRSL (RRRL RRLL RLLL ))
   (RELE LSEL (RRRL RRLL LRRL LRLL SRSL ))
   (RELE RSER (RRRR RRLR LRRR ))
   (RELE SESE (RELE ))
   (RELE ESES (ERRS ))
   (SLSR RRRR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (SLSR RRRL (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (SLSR RRLR (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (SLSR RRLL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (SLSR RLRR (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (SLSR RLLR (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (SLSR RLLL (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (SLSR LRRR (RLRR LRRR LRRL LLRR LLRL LERE ))
   (SLSR LRRL (RLRR LRRR LRRL LLRR LLRL LERE ))
   (SLSR LRLL (RRLR RRLL RLLR RLLL LRLL RELE ))
   (SLSR LLRR (RRRR RRRL RLRR LLRR LLRL ))
   (SLSR LLRL (RRRR RLRR LLRR LLRL ))
   (SLSR LLLR (RRLL LRLL LLLR LLLL ))
   (SLSR LLLL (RRLR RRLL LRLL LLLR LLLL ))
   (SLSR ELLS (LRLL LLLR LLLL ))
   (SLSR ERRS (LRRR LRRL LLRR LLRL LERE ))
   (SLSR LERE (RLRR LLRR LLRL ))
   (SLSR RELE (RLLR RLLL LLLR LLLL ELLS ))
   (SLSR SLSR (SLSR SRSL ))
   (SLSR SRSL (SLSR SRSL SESE ))
   (SLSR LSEL (LSEL RSER ))
   (SLSR RSER (LSEL RSER ESES ))
   (SLSR SESE (SLSR ))
   (SLSR ESES (LSEL ))
   (SRSL RRRR (RRRR RRRL RLRR LLRR LLRL ))
   (SRSL RRRL (RRRR RRRL RLRR LLRR ))
   (SRSL RRLR (RRLR RRLL LRLL LLLL ))
   (SRSL RRLL (RRLR RRLL LRLL LLLR LLLL ))
   (SRSL RLRR (RLRR LRRR LRRL LLRR LLRL LERE ))
   (SRSL RLLR (RRLR RRLL RLLR RLLL LRLL RELE ))
   (SRSL RLLL (RRLR RRLL RLLR RLLL LRLL RELE ))
   (SRSL LRRR (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (SRSL LRRL (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (SRSL LRLL (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (SRSL LLRR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (SRSL LLRL (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (SRSL LLLR (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (SRSL LLLL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (SRSL ELLS (RRLR RRLL RLLR RLLL RELE ))
   (SRSL ERRS (RRRR RRRL RLRR ))
   (SRSL LERE (RRRR RRRL LRRR LRRL ERRS ))
   (SRSL RELE (RRLR RRLL LRLL ))
   (SRSL SLSR (SLSR SRSL SESE ))
   (SRSL SRSL (SLSR SRSL ))
   (SRSL LSEL (LSEL RSER ESES ))
   (SRSL RSER (LSEL RSER ))
   (SRSL SESE (SRSL ))
   (SRSL ESES (RSER ))
   (LSEL RRRR (RRRR RRRL RLRR LLRR LLRL ))
   (LSEL RRRL (RRLL LRLL LLLR LLLL ))
   (LSEL RRLR (RRRR RLRR LLRR LLRL ))
   (LSEL RRLL (RRLR RRLL LRLL LLLR LLLL ))
   (LSEL RLRR (RLRR LRRR LRRL LLRR LLRL LERE ))
   (LSEL RLLR (RLRR LRRR LRRL LLRR LLRL LERE ))
   (LSEL RLLL (RRLR RRLL RLLR RLLL LRLL RELE ))
   (LSEL LRRR (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (LSEL LRRL (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (LSEL LRLL (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (LSEL LLRR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (LSEL LLRL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (LSEL LLLR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (LSEL LLLL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (LSEL ELLS (SLSR SRSL SESE ))
   (LSEL ERRS (SLSR SRSL ))
   (LSEL LERE (LSEL RSER ESES ))
   (LSEL RELE (LSEL RSER ))
   (LSEL SLSR (LRRR LRRL LLRR LLRL LERE ))
   (LSEL SRSL (LRLL LLLR LLLL ))
   (LSEL LSEL (RLLR RLLL LLLR LLLL ELLS ))
   (LSEL RSER (RLRR LLRR LLRL ))
   (LSEL SESE (LSEL ))
   (LSEL ESES (SLSR ))
   (RSER RRRR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (RSER RRRL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (RSER RRLR (RRRR RRRL LRRR LRRL LLRR LLRL ERRS LERE ))
   (RSER RRLL (RRLR RRLL RLLR RLLL LLLR LLLL ELLS RELE ))
   (RSER RLRR (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (RSER RLLR (RRRR RRRL RLRR LRRR LRRL ERRS ))
   (RSER RLLL (RLLR RLLL LRLL LLLR LLLL ELLS ))
   (RSER LRRR (RLRR LRRR LRRL LLRR LLRL LERE ))
   (RSER LRRL (RRLR RRLL RLLR RLLL LRLL RELE ))
   (RSER LRLL (RRLR RRLL RLLR RLLL LRLL RELE ))
   (RSER LLRR (RRRR RRRL RLRR LLRR LLRL ))
   (RSER LLRL (RRLR RRLL LRLL LLLL ))
   (RSER LLLR (RRRR RRRL RLRR LLRR ))
   (RSER LLLL (RRLR RRLL LRLL LLLR LLLL ))
   (RSER ELLS (SLSR SRSL ))
   (RSER ERRS (SLSR SRSL SESE ))
   (RSER LERE (LSEL RSER ))
   (RSER RELE (LSEL RSER ESES ))
   (RSER SLSR (RRRR RRRL RLRR ))
   (RSER SRSL (RRLR RRLL RLLR RLLL RELE ))
   (RSER LSEL (RRLR RRLL LRLL ))
   (RSER RSER (RRRR RRRL LRRR LRRL ERRS ))
   (RSER SESE (RSER ))
   (RSER ESES (SRSL ))
   (SESE RRRR (RRRR ))
   (SESE RRRL (RRRL ))
   (SESE RRLR (RRLR ))
   (SESE RRLL (RRLL ))
   (SESE RLRR (RLRR ))
   (SESE RLLR (RLLR ))
   (SESE RLLL (RLLL ))
   (SESE LRRR (LRRR ))
   (SESE LRRL (LRRL ))
   (SESE LRLL (LRLL ))
   (SESE LLRR (LLRR ))
   (SESE LLRL (LLRL ))
   (SESE LLLR (LLLR ))
   (SESE LLLL (LLLL ))
   (SESE ELLS (ELLS ))
   (SESE ERRS (ERRS ))
   (SESE LERE (LERE ))
   (SESE RELE (RELE ))
   (SESE SLSR (SLSR ))
   (SESE SRSL (SRSL ))
   (SESE LSEL (LSEL ))
   (SESE RSER (RSER ))
   (SESE SESE (SESE ))
   (SESE ESES (ESES ))
   (ESES RRRR (LLRR ))
   (ESES RRRL (LLLR ))
   (ESES RRLR (LLRL ))
   (ESES RRLL (LLLL ))
   (ESES RLRR (LRRR ))
   (ESES RLLR (LRRL ))
   (ESES RLLL (LRLL ))
   (ESES LRRR (RLRR ))
   (ESES LRRL (RLLR ))
   (ESES LRLL (RLLL ))
   (ESES LLRR (RRRR ))
   (ESES LLRL (RRLR ))
   (ESES LLLR (RRRL ))
   (ESES LLLL (RRLL ))
   (ESES ELLS (SRSL ))
   (ESES ERRS (SLSR ))
   (ESES LERE (RSER ))
   (ESES RELE (LSEL ))
   (ESES SLSR (ERRS ))
   (ESES SRSL (ELLS ))
   (ESES LSEL (RELE ))
   (ESES RSER (LERE ))
   (ESES SESE (ESES ))
   (ESES ESES (SESE ))))
